/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
package com.funambol.mailclient.ui.controller;

import com.funambol.mail.BodyPart;
import com.funambol.mail.Multipart;
import com.funambol.mailclient.Funambol;
import com.funambol.mailclient.cm.AlreadyExistentContactException;
import com.funambol.mailclient.cm.ContactManagerFactory;
import com.funambol.mailclient.sm.SyncClient;
import com.funambol.mailclient.ui.utils.ImageAttachment;

import com.funambol.mailclient.ui.utils.UiUtils;
import com.funambol.mailclient.ui.view.AboutScreen;
import com.funambol.mailclient.ui.view.AccountSettingsForm;
import com.funambol.mailclient.ui.view.AdCanvas;
import com.funambol.mailclient.ui.view.AddContactForm;
import com.funambol.mailclient.ui.view.AdvancedContactForm;
import com.funambol.mailclient.ui.view.AttachmentsList;
import com.funambol.mailclient.ui.view.ComposeMessageForm;
import com.funambol.mailclient.ui.view.FolderList;
import com.funambol.mailclient.ui.view.Ads;
import com.funambol.mailclient.ui.view.ContactList;
import com.funambol.mailclient.ui.view.ViewMessage;
import com.funambol.mailclient.ui.view.FunambolAlert;
import com.funambol.mailclient.ui.view.GeneralSettingsForm;
import com.funambol.mailclient.ui.view.HelpScreen;
import com.funambol.mailclient.ui.view.LinkList;
import com.funambol.mailclient.ui.view.LogViewerForm;
import com.funambol.mailclient.ui.view.ContactPhoneNumbersList;
import com.funambol.mailclient.ui.view.Drawer;
import com.funambol.mailclient.ui.view.UpdateAlert;
import com.funambol.mailclient.ui.view.SettingsList;
import com.funambol.mailclient.ui.view.DraftMessageList;
import com.funambol.mailclient.ui.view.InboxMessageList;
import com.funambol.mailclient.ui.view.MessageList;
import com.funambol.mailclient.ui.view.OutboxMessageList;
import com.funambol.mailclient.ui.view.SentMessageList;
import com.funambol.mailclient.ui.view.RecipientList;
import com.funambol.mailclient.ui.view.ModalPopup;
import com.funambol.mailclient.ui.view.PlatformRequestPopupAction;


import com.funambol.mailclient.UpdaterManager;
import com.funambol.mailclient.loc.Localization;
import com.funambol.mailclient.cm.Contact;
import com.funambol.mailclient.cm.ContactManager;
import com.funambol.mailclient.cm.ContactManagerException;
import com.funambol.mailclient.ui.view.ViewAttachedImageScreen;
import com.funambol.mailclient.mm.MessageManager;

import com.funambol.mailclient.config.*;
import com.funambol.mailclient.Account;

import com.funambol.mail.Address;
import com.funambol.mail.Folder;
import com.funambol.mail.MailException;
import com.funambol.mail.Message;
import com.funambol.mail.MessageFlags;
import com.funambol.mail.Store;

import com.funambol.mailclient.CTPManager;
import com.funambol.mailclient.ui.view.DrawerFactory;
import com.funambol.syncml.spds.SyncException;
import com.funambol.syncml.spds.SourceConfig;
import com.funambol.syncml.protocol.SyncML;
import com.funambol.syncml.devinf.DevInf;
import com.funambol.syncml.devinf.Ext;

import com.funambol.util.ConsoleAppender;
import com.funambol.util.MailDateFormatter;
import com.funambol.util.RMSAppender;
import com.funambol.util.StringUtil;
import com.funambol.push.PushConfig;
import com.funambol.util.CodedException;
import com.funambol.util.ConnectionListener;
import com.funambol.util.ConnectionManager;
import com.funambol.util.ThreadPool;
import com.funambol.util.Log;
import com.funambol.util.MultipleAppender;
import com.funambol.util.SocketAppender;
import com.funambol.util.ThreadPoolMonitor;

import java.io.IOException;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;
import java.util.Vector;

import javax.microedition.io.ConnectionNotFoundException;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Item;
import javax.microedition.midlet.MIDlet;
import javax.microedition.rms.RecordStoreException;

//#ifndef noPhoto
//# import com.funambol.mailclient.ui.view.CameraCanvas;
//# import com.funambol.mailclient.ui.view.SendPhotoScreen;
//#endif

//#ifdef isBlackberry
//# import com.funambol.util.BlackberryUtils;
//# import net.rim.blackberry.api.browser.Browser;
//# import net.rim.blackberry.api.browser.BrowserSession;
//#endif


/**
 * It is the Controller class that controls all interactions
 * between screens and the model
 * It maintains a pool of shared UI instances
 */
public class UIController {

    private static final String RE = Localization.getMessages().RE_LABEL;
    private static final String FW = Localization.getMessages().FW_LABEL;
    public static final int CONNECTION_RETRY_TIME = 5;
    public static final int SENT_MESSAGE = 0;
    public static final int OUTGOING_MESSAGE = 1;
    public static final int INCOMING_MESSAGE = 2;
    public static final int COMMAND_TYPE = Command.OK;
    //Possible sync caller
    public static final int USER = 0;
    public static final int SAN_MESSAGE = 1;
    public static final int SCHEDULER = 2;
    public static final int CONNECTION_ERROR_TIMER = 3;
    public static int alarmCounter = 0;
    public static Funambol midlet;
    public static Display display;
    // The command pool
    //Blackberry gets low priority because softkeys include a back button. 
    //#ifdef isBlackberry
    //# public static Command backCommand = new Command(Localization.getMessages().BACK_COMMAND, Command.BACK, 99);
    //#else 
    public static Command backCommand =
            new Command(Localization.getMessages().BACK_COMMAND,
            Command.BACK, 0);
    //#endif
    public static Command selectCommand =
            new Command(Localization.getMessages().SELECT_COMMAND,
            UIController.COMMAND_TYPE, 0);
    public static Command cancelCommand =
            new Command(Localization.getMessages().CANCEL_COMMAND,
            Command.BACK, 10);
    public static Command saveCommand =
            new Command(Localization.getMessages().SAVE_COMMAND,
            UIController.COMMAND_TYPE, 1);
    public static Command inboxCommand =
            new Command(Localization.getMessages().INBOX_COMMAND,
            UIController.COMMAND_TYPE, 1);
    public static Command blackberryExitCommand = new Command(Localization.getMessages().EXIT_COMMAND_LABEL, Command.EXIT, 100);
    public static Command nextCommand = new Command(Localization.getMessages().MESSAGE_VIEW_NEXT_MESSAGE, UIController.COMMAND_TYPE, -2);
    public static Command previousCommand = new Command(Localization.getMessages().MESSAGE_VIEW_PREVIOUS_MESSAGE, UIController.COMMAND_TYPE, -1);
    // The contact manager
    private static ContactManager contactManager;
    // The screen pool
    public static ComposeMessageForm composeMessageScreen;
    public static LogViewerForm logViewerScreen;
    public static GeneralSettingsForm getMailSettingsScreen;
    private static InboxMessageList inboxMessageList;
    private static OutboxMessageList outboxMessageList;
    private static SentMessageList sentMessageList;
    private static DraftMessageList draftMessageList;
    protected static ContactList contactList;
    // The current message view
    private static ViewMessage viewMessageScreen;
    // The screen stack
    public static Stack backStack = new Stack();
    // Thread pool
    private static ThreadPool threadPool;
    private static Ads ad;
    private ThreadPoolMonitor uiThreadMonitor;
    private static final int MAX_NUM_THREADS = 5;
    public static MessageManager messageManager = MessageManager.getInstance();
    public static MailClientConfig mailClientConfig;
    // Folder informations
    private static Folder[] allFolders;
    public static boolean otaStarted;
    //public static long startAppProbe;
    public static long startupFreeMem;
    //private static long heapSize = Runtime.getRuntime().totalMemory();
    // private static ContactListLoader contactListLoader;
    private static MessageWriter messageWriter;
    private static PlatformRequestHandler prh;
    private static Drawer drawer;
    private static FolderList folderList;
    /** connection availability: if false the user must exit the application on:
     * Nokia and SonyEricsson;
     * Motorola For Linux OS;
     **/
    private static boolean offlineMode = false;
    /** Holds the number of unread messages in the inbox. This field is not
     * updated by the UIController directly, but each class that can change this
     * value is responsible for keeping it up to date 
     **/
    private static int inboxUnread = 0;
    public static AccountSettingsForm accountSettingsForm;
    /**
     * True if this is the first sync action for this application session
     * This force contacts sync at the first sync session performed by the
     * user.
     */
    public static boolean isFirstSync = true;
    //#ifndef noPhoto
    //# public static CameraCanvas cameraCanvas;
    //#endif
    private static ContactsLoader contactsLoader;
    //used for temporary bb fix 
    private static long lastTimeStarKeypressed = 0;
    public static AppProperties appProperties;
    private static ConnectionManager connectionManager = null;
    //The sync caller agent
    private static int syncCaller = USER;

    //public static boolean WAP_SIMULATION = true;
    private UIController() {
    }

    public static void init(Funambol app) {
        midlet = app;
        display = Display.getDisplay(app);
        appProperties = new AppProperties(app);
        isFirstSync = true;
        connectionManager = ConnectionManager.getInstance();
    //#ifdef isBlackberry
    //# connectionManager.setConnectionListener(new UIConnectionListener());
    //#endif
    }

    public static void initThreadPool() {
        ThreadPoolMonitor uiThreadMonitor = new UIThreadPoolMonitor();
        threadPool = new ThreadPool(uiThreadMonitor, MAX_NUM_THREADS);
    }

    public static ThreadPool getThreadPool() {
        return threadPool;
    }

    public static void initLogger() {


        MultipleAppender appender = new MultipleAppender();
        //appender.addAppender(new SocketAppender("85.18.37.27:5123"));

        // Set the appropriate appender and log level.
        String logAppender = UIController.appProperties.get(AppProperties.LOG_APPENDER);
        if (logAppender != null) {
            // trimming the property
            logAppender = logAppender.trim();
        }

        if ("console".equals(logAppender)) {
            appender.addAppender(new ConsoleAppender());
//#ifdef SOCKET_APPENDER
//#     } else if ("socket".equals(logAppender)) {
//#         String socketServer = midlet.getAppProperty("LogSocketUrl");
//#         appender.AddAppender(new SocketAppender(socketServer));
//#endif
        } else { // using rmsappender
            appender.addAppender(new RMSAppender(RMSAppender.LOGDBNAME));
        }

        /*appender.addAppender(new ConsoleAppender());
        appender.addAppender(new RMSAppender(RMSAppender.LOGDBNAME));
        Log.setLogLevel(Log.DEBUG);    */
        Log.initLog(appender, Log.getLogLevel());

    }

    /**
     * Get the permission connection: if false the client
     * cannot connect to the network
     * @return true if the connection has been granted by the user
     */
    
    
    public static boolean isSyncPermitted() {
        
        boolean ret = true;
      
          switch (ServerCapFiller.getStatus()) {
             
            case ServerCapFiller.STAUS_CHECKED:
                try {
                    ret = (isSmartSlowSyncSupported()) ;
                } catch (ConfigException e) {
                    // exception should never happens because status is CHECKED
                    e.printStackTrace();
                    Log.error("[UICOntroller.issyncPermitted]: configException : " + e);
                    
                    
                }
                break;
            case ServerCapFiller.STAUS_CHECK_FAILED:
            case ServerCapFiller.STAUS_UNCHEKED:
                ret = true;
                break;
            default:
                // STAUS_CHECKING 
                ret = false;
                break;
            
        }
        Log.debug("ret = " + ret );
          return ret && (!isSyncInProgress()) && !isOfflineMode()  ;
    }

    /**
     * @return true if commands that performs online operations (like send log, 
     * get mail, update contacts etc.) can be used 
     * 
     */
    public static boolean isOkToAddOnlineCommands() {
        Log.debug("[UIcontroller.isOkToAddOnlineCommands] : returning " + isSyncPermitted()) ;
        return isSyncPermitted();
         
    }
    
    
    /**
     * Set the offline mode for this app session: if true the client
     * cannot connect to the network.
     * changing the offline mode here will change also the CTPService online 
     * mode managed by the CTPManager instance
     * @param mode set the offline mode
     */
    protected static void setOfflineMode(boolean mode) {

        offlineMode = mode;
        CTPManager.getInstance().setOfflineMode(mode);
    }

    /**
     * 
     * @return true if the app is currently in offline mode
     */
    public static boolean isOfflineMode() {
        return offlineMode;
    }

    /**
     * enable or disable the sync commands in different view screens
     *
     * @param enable enable the commands if true, disable the commands if false
     */
    public static void enableSyncCommands(boolean enable) {
        Log.info("Enable Client's Sync Commands: " + enable);
        if (contactList != null) {
            contactList.enableSyncCommand(enable);
        }

        if (inboxMessageList != null) {
            getInboxMessageList().enableSyncCommand(enable);
        }

        if (composeMessageScreen != null) {
            getComposeMessageScreen().enableSendCommand(enable);
        }

        if (viewMessageScreen != null) {
            viewMessageScreen.enableFullMessageCommand(enable);
        }

        if (logViewerScreen != null) {
            logViewerScreen.enableSendCommand(enable);
        }

        if (getMailSettingsScreen != null) {
            getMailSettingsScreen.enableResetInboxCommand(enable);
        }

        if (accountSettingsForm != null) {
            accountSettingsForm.enableSaveCommand(enable);
        }
    }

    /**
     * enable / disable the sync commands, but keep settings "save" command 
     * always enabled
     * @param enable if true the commands will be enabled, if false 
     * the commands will be disabled
     */
    public static void enableSyncCommandsKeepingSettings(boolean enable) {
        // setOfflineMode(!enable);
        enableSyncCommands(enable);
        if (!enable) {
            if (accountSettingsForm != null) {
                accountSettingsForm.enableSaveCommand(true);
            }
        }
    }

    /**
     * init the inbox: calls initmessagemanager, displays
     * the inbox with the cached messages, then starts the thread that loads the
     * messages from the rms
     *
     * @return true if the account has been set, false otherwise.
     * The account is considered set if the url is different from
     * Account.DEFAULT_URL and if the username and password are not empty.
     *
     */
    public static boolean initInbox() {
        boolean accountSet = false;

        try {

            inboxMessageList = new InboxMessageList(new Vector());
            outboxMessageList = null;
            draftMessageList = null;
            sentMessageList = null;

            accountSet = mailClientConfig.getMailAccount().isSet();

            // If the account information has been already set
            if (accountSet) {
                /*display.setCurrent(inboxMessageList);
                inboxMessageList.repaint();
                inboxMessageList.serviceRepaints();*/
                // this starts the thread that load messages from rms

                //Thread removed for all devices
                //Thread t = threadPool.startThread(inboxMessageList);
                //t.setPriority(Thread.MIN_PRIORITY);
                inboxMessageList.load();
                //checkForSmartSlowSync();
            } else {
                Log.info("initInbox: go to account settings.");

                // Some devices, like the RAZR, don't show two display
                // if the calls to display.setcurrent are too close.
                //sleep(10);
                showAlert(Localization.getMessages().CONFIG_NOT_SET,
                        AlertType.INFO, false, getAccountSettingsForm(inboxMessageList));


                // setting minimum displayed message count
                inboxMessageList.setMinimumDisplayedMessageCount(
                        InboxMessageList.COUNT_NONE);
            }

        } catch (Exception ex) {
            Log.error("[initInbox] Error: " + ex);
            ex.printStackTrace();
        }
        return accountSet;
    }

    /**
     * @return true if smart slow sync is supported, false otherwhise
     */
    public static boolean checkForSmartSlowSync() throws ConfigException, CodedException {

        boolean r = false;



        //disable commands
        UIController.enableSyncCommands(false);
            r = isSmartSlowSyncSupported();

        if (r) {
            // if we can proceed we can reenable the commands
            enableSyncCommands(true);
        }
        //getInboxMessageList().resetTitle();
        return r;
    }

    public static boolean isSmartSlowSyncSupported() throws ConfigException, CodedException {

        boolean ret = false;
        DevInf sc = ServerCapFiller.getServerCapabilities();
        Vector exts = sc.getExts();
        for (int i = 0; i <
                exts.size(); i++) {
            if (((Ext) exts.elementAt(i)).getXNam().equals(Ext.X_FUNAMBOL_SMARTSLOW)) {
                Log.debug("\n\n ###### smartslow supported  from the config ##### \n\n");
                ret =
                        true;
                break;
            }

        }
        return ret;

    }

    /**
     * Suspend the current thread for the given number of seconds
     *
     * @param millis the time to wait (milliseconds)
     */
    public static void sleep(int millis) {
        try {
            Thread.sleep(millis);
        } catch (Exception e) {
            Log.error("sleep interrupted.");
        }

    }

    /**
     * init the messagemanager and the store
     */
    public static void initMessageManager() {
        try {
            //Log.debug("MessageManager init");
            messageManager = MessageManager.getInstance();
            initStore(false);

        } catch (Exception ex) {
            Log.error("UIController: error init MessageManager " + ex);
            ex.printStackTrace();
        }

    }

    /**
     * init the message store
     * @param reset if true the folders will be erased and recreated
     */
    public static void initStore(boolean reset) throws MailException {
        messageManager.initStore(reset);
        if (reset) {
            allFolders = null;
        }

    }

    /**
     *
     * showXXX methods managing the views
     *
     */
    /**
     * This method retrieves the screen to go back from the Stack
     */
    public static void showBackScreen() /*throws Exception*/ {
        try {
            Displayable screen = backStack.pop();
            // If the screen is the inbox, cleanup the other screens
            if (screen == inboxMessageList) {
                showInboxScreen();
            } else {
                display.setCurrent(screen);
            }

        } catch (Exception ex) {
            Log.error("ShowBackScreen: " + ex.toString());
            showInboxScreen();
        }

    }

    /**
     * show the current composeMessageScreen, performing no updates. <br/>
     * @param backScreen the screen that needs to be bounded to the back button
     * in the compose message screen
     * @param item the item that will be focused
     *
     * if you need to update the messagescreen use updateComposeMessageScreen
     * functions
     **/
    public static void showComposeMessageScreen(Displayable backScreen, Item item) {
        if (backScreen != null) {
            backStack.push(backScreen);
        } else {
            backStack.push(inboxMessageList);
        }

        getComposeMessageScreen().setDefaultTitle();
        display.setCurrentItem(item);
    }

    public static void notifyNewMandatoryUpdate(String version) {
        Log.debug("[UIController] new mandatory update notified");
        UpdateAlert alert = new UpdateAlert(true, version);
        alert.showModal(display);
        inboxMessageList.enableUpdateCommand(true);
    }

    public static void notifyNewOptionalUpdate(String version) {
        Log.debug("[UIController] new optional update notified");
        UpdateAlert alert = new UpdateAlert(false, version);
        alert.showModal(display);
        inboxMessageList.enableUpdateCommand(true);
    }

    public static void update() {
        UIController.openUrl(UpdaterManager.getInstance().getDownloadUrl());
    }

    /**
     * show the compose message screen ready for a new message to be composed
     */
    public static void composeNewMessage(Displayable backScreen) {
        if (!contactsLoader.isLocked()) {
            Message m = new Message();
            getComposeMessageScreen().setMessage(new Message());
            // we need to set the message here, because
            // composemessagescree.setmessage does not
            // (for speed reasons)
            getContactList().setMessage(m);
            getContactList().emptySearchString();
            getContactList().SortAlphabetically();
            showContactList(display.getCurrent());
        } else {
            showErrorAlert(
                    Localization.getMessages().CONTACTSLOADER_LOCKED_ERROR,
                    backScreen);
        }

    }

    /**
     * update ComposeMessageScreen message.
     * the message remains unchanged
     **/
    public static void updateComposeMessageScreen(Message message) {
        getComposeMessageScreen().setMessage(message);

    }

    /**
     * update ComposeMessageScreen toAppend string.
     * the toAppend string remains unchanged
     **/
    public static void updateComposeMessageScreen(String toAppend) {
        getComposeMessageScreen().setToAppend(toAppend);
    }

    /**
     * update ComposeMessageScreen toAppend string and message
     **/
    public static void updateComposeMessageScreen(Message message, String toAppend) {
        updateComposeMessageScreen(message);
        updateComposeMessageScreen(toAppend);
    }

    /**
     * return the composemessageform and create it if needed
     */
    public static ComposeMessageForm getComposeMessageScreen() {
        if (composeMessageScreen == null) {
            composeMessageScreen = new ComposeMessageForm();
        }

        return composeMessageScreen;
    }

    /**
     *  show the inbox screen, cleaning the stack and freeing not used objects
     * and memory
     */
    public static void showInboxScreen() {
        backStack.clear();
        outboxMessageList =
                null;
        sentMessageList =
                null;
        draftMessageList =
                null;
        composeMessageScreen =
                null;

        if (!isSyncInProgress() && !ServerCapFiller.isGettingServerCapabilities()) {
            getInboxMessageList().resetTitle();
        }

        getInboxMessageList().toNextAd();
        display.setCurrent(getInboxMessageList());
    //#ifdef low_mem
//#         freeMemory();
    //#endif
    }

    /** If the freeMemory is low, try to collect some memory */
    public static long freeMemory() {

        long mem = Runtime.getRuntime().freeMemory();
        if (mem < 10000) {
            Log.info(">> freeMemory is low: " + Runtime.getRuntime().freeMemory());
            try {
                System.gc();
                Thread.sleep(1);
            } catch (InterruptedException ex) {
                // just ignore it
                Log.error("interrupted exception freeing memory");

            }

            mem = Runtime.getRuntime().freeMemory();
        }

        return mem;
    }

    /**
     * Display the outbox screen.
     */
    public static void showOutboxScreen(Displayable backScreen) {
        backStack.push(backScreen);
        //TODO: use lazy initInbox
        updateOutboxMessageList(null);
        display.setCurrent(getOutboxMessageList());
    }

    /**
     * push current screen in the backstack and display the sent message list
     *
     *@param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static void showSentScreen(Displayable backScreen) {
        backStack.push(backScreen);
        updateSentMessageList(null);
        UIController.display.setCurrent(getSentMessageList());
    }

    /**
     * push current screen in the backstack and display the draft message list
     *
     *@param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static void showDraftScreen(Displayable backScreen) {
        backStack.push(backScreen);
        updateDraftMessageList(null);
        UIController.display.setCurrent(getDraftMessageList());
    }

    /**
     * push current screen in the backstack and display the view message screen
     * with the given message.
     *<br>
     *the message read flag will be set to true if needed
     *
     *
     *
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     * @param message the message to be displayed
     */
    public static void showViewMessageScreen(Displayable backScreen, Message message) {
        backStack.push(backScreen);
        Log.debug("message flag opened = " + message.getFlags().isSet(MessageFlags.OPENED));
        if (!message.getFlags().isSet(MessageFlags.OPENED)) {
            changeReadFlag(message);
        }

        viewMessageScreen = new ViewMessage(message);
        viewMessageScreen.resetTitle();
        if (!contactsLoader.isLocked()) {
            viewMessageScreen.enableCallCommand();
        }

        display.setCurrent(viewMessageScreen);
    }

    public static void enableCallSenderCommand() {
        if (display.getCurrent() instanceof ViewMessage) {
            viewMessageScreen.enableCallCommand();
        }

    }

    /**
     * Create the folder list and display it if not yet created.
     *
     * @param backscreen the displayable to be pushed in the stack,
     * @param selectedFolder the folder to be selected showing the list
     * often the current displayable
     */
    public static void showFolderList(Displayable displayable, int selectedFolder) {
        backStack.push(displayable);
        if (folderList == null) {
            folderList = new FolderList();
        }

        folderList.updateCounters();
        folderList.setSelectedFolder(selectedFolder);
        display.setCurrent(folderList);
    }

    /**
     * Create the folder list and display it
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static void showFolderList(Displayable displayable) {
        showFolderList(displayable, MessageManager.INBOX);
    }

    /**
     * opens a list of links in the given message body
     * @param body the string to be searched for links
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     *
     */
    public static void showLinkList(Displayable displayable, String body) {
        backStack.push(displayable);
        display.setCurrent(new LinkList(body));
    }

    /**
     * opens a list of attachments in the given message
     * @param backscreen the displayable to be pushed in the stack,
     * @param message containing the attachments
     * often the current displayable
     *
     */
    public static void showAttachmentsList(Displayable displayable, Message message) {
        backStack.push(displayable);
        display.setCurrent(new AttachmentsList(message));
    }

    /*
    public static void showPhoneNumberList(Displayable displayable, String body) {
    backStack.push(displayable);
    display.setCurrent(new PhoneNumberList(body));
    }
     */
    /**
     * Methods to show settings screens
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     *
     */
    public static void showSettings(Displayable displayable) {
        backStack.push(displayable);

        display.setCurrent(new SettingsList());
    }

    /**
     *show account settings form
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     *
     */
    public static void showAccountSettings(Displayable displayable) {
        display.setCurrentItem(getAccountSettingsForm(displayable).getFocusedItem());

    }

    /**
     * @return the account settings form
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static AccountSettingsForm getAccountSettingsForm(
            Displayable displayable) {
        backStack.push(displayable);
        if (accountSettingsForm == null) {
            accountSettingsForm = new AccountSettingsForm();
        }

        return accountSettingsForm;
    }

    /**
     * show the mail sync settings form
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static void showMailSyncSettings(Displayable displayable) {
        backStack.push(displayable);
        if (getMailSettingsScreen == null) {
            getMailSettingsScreen = new GeneralSettingsForm();
        }

        display.setCurrent(getMailSettingsScreen);
    }

    /**
     * show the log view form
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static void showLogViewer(Displayable displayable) {
        backStack.push(displayable);
        logViewerScreen =
                new LogViewerForm();
        display.setCurrent(logViewerScreen);
    }

    /**
     * show the recipient list form
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static void showRecipientsList(Displayable displayable, Message message) {
        backStack.push(displayable);
        display.setCurrent(new RecipientList(message));
    }

    /**
     * show the contact list
     * @param backscreen the screen to be put in the stack for future back commands
     */
    public static void showContactList(Displayable backScreen) {
        if (!contactsLoader.isLocked()) {
            backStack.push(backScreen);
            getContactList().rewindList();
            getContactList().resetSubtitle();
            display.setCurrent(getContactList());
        } else {
            //show alert to inform the user that the contact list is needed 
            //to perform this operation and he must wait the full contacts 
            //cache loading
            showErrorAlert(
                    Localization.getMessages().CONTACTSLOADER_LOCKED_ERROR,
                    backScreen);

        }

    }

    public static void showAddContactScreen(Displayable displayable,
            ContactList addressList) {
        backStack.push(displayable);
        display.setCurrent(new AddContactForm(addressList));
    }

    public static void showAddContactScreen(Displayable displayable) {
        showAddContactScreen(displayable, (ContactList) null);
    }

    public static void showAddContactScreen(Displayable displayable, Contact contact) {
        backStack.push(displayable);
        UIController.display.setCurrent(new AddContactForm(contact, getContactList(), AddContactForm.MODE_ADD_CONTACT));
    }

    /**
     * displays a edit contact screen and update the given FunAddressList after
     * the edit.
     *
     *
     * @param displayable: the displayable to be pushed in the stack
     * contact: the contact to be edited
     * contactList: the adddresslist to be updated (can be null if not needed)
     */
    public static Displayable showEditContactScreen(
            Displayable displayable,
            Contact contact, ContactList contactList, int mode) {
        backStack.push(displayable);
        Displayable contactForm = new AddContactForm(contact, contactList, mode);
        UIController.display.setCurrent(contactForm);
        return contactForm;
    }

    /**
     * Show an info alert with autodismiss
     */
    public static void showAlert(String message) {
        showAlert(message, AlertType.INFO, true);
    }

    /**
     * Show an info alert with autodismiss and a displayable
     * to open after it's been dismissed.
     */
    public static void showAlert(String message, Displayable displayable) {
        showAlert(message, AlertType.INFO, true, displayable);

    }

    /**
     * Show an error alert without autodismiss
     */
    public static void showErrorAlert(String message) {
        showAlert(message, AlertType.ERROR, false);
    }

    /**
     * Show an error alert with details command for longer message
     */
    public static void showErrorDetailedAlert(String message, String longMessage) {
        FunambolAlert messageAlert = getFunambolDetailedAlert(message, longMessage, AlertType.ERROR, false);
        if (!messageAlert.isShown) {
            messageAlert.isShown = true;
            display.setCurrent(messageAlert);
        }

    }

    /**
     * Show an info alert without autodismiss
     */
    public static void showInfoAlert(String message) {
        showAlert(message, AlertType.INFO, false);
    }

    /**
     * Show an error alert without autodismiss and a displayable
     * to open after it's been dismissed.
     */
    public static void showErrorAlert(String message, Displayable displayable) {
        showAlert(message, AlertType.ERROR, false, displayable);
    }

    /**
     * Show an alert with given message, alert type and autodismiss.
     * This is the generic method called by the others.
     */
    private static void showAlert(String message, AlertType alertType, boolean autoDismiss) {
    Log.debug("Showing alert with message: " + message);
        FunambolAlert messageAlert = getFunambolAlert(message, alertType, autoDismiss);
        if (!messageAlert.isShown) {
            messageAlert.isShown = true;
            display.setCurrent(messageAlert);
        }

    }

    /**
     * Show an alert with given message, alert type, autodismiss and next displayable
     */
    public static void showAlert(String message, AlertType alertType,
            boolean autoDismiss, Displayable displayable) {
        // needs final Alert for different managing  of alert
        // for issue in some Nokia devices like 6600
        final FunambolAlert messageAlert = getFunambolAlert(message, alertType, autoDismiss);
        messageAlert.setNextScreen(displayable);
        if (!messageAlert.isShown) {
            messageAlert.isShown = true;
            //#ifndef JVMAlertDismiss
            display.setCurrent(messageAlert);
        //#else
        //#  //Solution manage alert for known issue in Nokia 6600
        //#  display.setCurrent(displayable);
        //#  display.callSerially(new Runnable() { public void run() {display.setCurrent(messageAlert);} });
        //#endif
        }

    }

    /**
     * Show a modal alert. The method does not return until the user closes the
     * alert.
     *
     * @param message the message to display
     */
    public static void showModalAlert(String message) {
        FunambolAlert messageAlert = getFunambolAlert(message, AlertType.INFO, false);
        messageAlert.showModal(display);
    }

    public static void showAbout(Displayable displayable) {
        backStack.push(displayable);
        //display.setCurrent(new AboutForm());
        display.setCurrent(new AboutScreen());
    }

    public static void showHelp(Displayable displayable) {
        backStack.push(displayable);
        HelpScreen helpScreen = new HelpScreen(midlet);
        display.setCurrent(helpScreen);
    }

    public static void showHelpSection(Displayable displayable,
            Displayable sectionView) {
        backStack.push(displayable);
        display.setCurrent(sectionView);
    }

    /**
     * Utilites methods managing the Model
     */
    public static void replyMessage(Message message) {
        Message replyMessage = new Message();
        //TODO: exception handling
        try {
            replyMessage.setTo(message.getReplyTo());
            replyMessage.setSubject(RE + message.getSubject());
        } catch (MailException ex) {
            ex.printStackTrace();
            Log.error("unable to set content into reply " +
                    "message, error getting 'from' field from message");
        }

        setDelayedFlag(message, MessageFlags.ANSWERED);
        updateComposeMessageScreen(replyMessage, getReplyText(message));
        // getContactList().emptySearchString();
        showComposeMessageScreen(display.getCurrent(), getComposeMessageScreen().body);
    }

    /**
     * Put the application in background. This method does not work for any
     * device.
     */
    public static void background() {
        // This works only on some devices. Shall we use ifdefs?
        backStack.clear();
        display.setCurrent(null);
    }

    /**
     * set the message as the original message in composemessagescreen, the next
     * time the send / sendlater commandaction is performed the given flag will
     * be set to true
     *
     * @param message the message to be set as the original message in
     * composemessageform
     *
     * @param flag the flag (one of MessageFlags constants) to be set to true
     */
    private static void setDelayedFlag(final Message message,
            final int flag) {
        //Log.debug("UIController: trying to set read message flag");
        //setRepliedFlag(message);
        MessageFlags flags = new MessageFlags();
        flags.setFlags(message.getFlags().getFlags());
        if (!flags.isSet(flag)) {
            Log.debug("[UIController.setDelayedFlag] Delayed flag added");
            //>>>>FIXME: Transfer on ComposeMessageForm
            getComposeMessageScreen().setMessageFlag(flag);
            //messageManager.getInstance().updateMessageFlag(message, flag, true);
            try {
                Log.debug("message: " + message);
                getComposeMessageScreen().setOriginalMessage(message);
            } catch (MailException ex) {
                Log.error("error forwarding message while creating messageinfo " +
                        "from original message");
                ex.printStackTrace();
            }

        }
    }

    /*private static void delayedFlag(final Message message, final int flag) {
    //Log.debug("UIController: trying to set read message flag");
    //setRepliedFlag(message);
    MessageFlags flags = new MessageFlags();
    flags.setFlags(message.getFlags().getFlags());
    if (!flags.isSet(flag)) {
    flags.setFlag(flag, true);
    getComposeMessageScreen().setFlagsToSet(flags);
    try {
    getComposeMessageScreen().setOriginalMessage(message);
    } catch (MailException ex) {
    Log.error("error forwarding message while creating messageinfo " +
    "from original message");
    ex.printStackTrace();
    }
    }
    }*/
    /**
     * create a new forward message and show the compose message screen
     *
     * @param message the message to be forwarded (body content will be appended
     * at the bottom of the email)
     */
    public static void forwardMessage(Message message) {

        Message forwardMessage = new Message();

        forwardMessage.setSubject(FW + message.getSubject());
        setDelayedFlag(message, MessageFlags.FORWARDED);
        UIController.updateComposeMessageScreen(forwardMessage, getForwardText(message));
        // getContactList().emptySearchString();
        showComposeMessageScreen(display.getCurrent(), getComposeMessageScreen().recipientStringItem);
    /*  getContactList().setMessage(forwardMessage);
    getContactList().emptySearchString();
    getContactList().SortAlphabetically();
    showContactList(display.getCurrent()); */

    }
    /*
    public static void forwardMessage(Message message) {
    Message forwardMessage = new Message();
    forwardMessage.setSubject(FW + message.getSubject());
    delayedFlag(message, MessageFlags.FORWARDED);
    updateComposeMessageScreen(forwardMessage, getForwardText(message));
    // getContactList().emptySearchString();
    showComposeMessageScreen(display.getCurrent(), getComposeMessageScreen().recipientStringItem);
    }*/

    /**
     * update the message list that contain the given message
     *
     * @param message the message
     */
    private static void updateMessageList(Message message) {
        if (message.getParent() == null) {
            //updateAllMessageLists(message);
            Log.error("Message without parent");
            return;
        } else {
            if (message.getParent().getName().equals(Store.INBOX)) {
                //Log.debug("UIController: message from inbox, updating inbox");
                updateInboxMessageList(message);
            } else if (message.getParent().getName().equals(Store.OUTBOX)) {
                //Log.debug("UIController: message from outbox, updating outbox");
                updateOutboxMessageList(message);
            } else if (message.getParent().getName().equals(Store.SENT)) {
                //Log.debug("UIController: message from sent, updating sent");
                updateSentMessageList(message);
            } else if (message.getParent().getName().equals(Store.DRAFTS)) {
                //Log.debug("UIController: message from draft, updating draft");
                updateDraftMessageList(message);
            } else {
                Log.error("Unkown folder");
            }

        }

    }

    public static void updateMessageList(Object o, int theFolder) {
        MessageList messageList;
        switch (theFolder) {
            case MessageManager.INBOX:
                messageList = getInboxMessageList();
                break;
            case MessageManager.OUTBOX:
                messageList = getOutboxMessageList();
                break;
            case MessageManager.DRAFTS:
                messageList = getDraftMessageList();
                break;
            case MessageManager.SENT:
                messageList = getSentMessageList();
                break;
            default:
                messageList = getInboxMessageList();
        }

        if (o == null) {
            messageList.setTitle(messageList.getDefaultTitle());
            messageList.setMessageList(getSortedMessages(theFolder));
        } else if (o instanceof Message) {
            messageList.setMessageList(getSortedMessages(theFolder));
        } else if (o instanceof String) {
            if (o.toString().length() == 0) {
                messageList.setTitle(messageList.getDefaultTitle());
            } else {
                messageList.setTitle(o.toString());
            }

        }
    }

    public static void updateDraftMessageList(Object o) {
        updateMessageList(o, MessageManager.DRAFTS);
    }

    public static void updateSentMessageList(Object o) {
        updateMessageList(o, MessageManager.SENT);
    }

    public static void updateInboxMessageList(Object o) {
        updateMessageList(o, MessageManager.INBOX);
    }

    public static void updateOutboxMessageList(Object o) {
        updateMessageList(o, MessageManager.OUTBOX);
    }
//    private static void debug(String s) {
//        Log.debug("UIController:"+ s);
//    }
//    private static void error(String s) {
//        Log.error("UIController:"+ s);
//    }
    /**
     * open a url.
     *
     * @param url the url to be opened in the default browser (device dependent)
     */
    public static void openUrl(String url) {
        Log.info("Opening url: [" + url + "]");

        
        // In Nokia S60 device the platformRequest
        // doesn't open link without "http://"
        if (url.startsWith("www")) {
            url = "http://" + url;
        }


        //#ifdef isBlackberry
        //# BrowserSession bSession = Browser.getDefaultSession();
        //# bSession.displayPage(url);
        //#else
        try {
            midlet.platformRequest(url);
        } catch (ConnectionNotFoundException ex) {
            ex.printStackTrace();
            Log.error("openUrl: " + ex.toString());
            showErrorAlert("Error opening URL.");
        } catch (Exception e) {
            e.printStackTrace();
            Log.error("openUrl: " + e.toString());
        }
        //#endif
       

    }

    public static void dialNumber(String number) {
        try {
            doPlatformRequest("tel:" + number);
        } catch (Exception ex) {
            ex.printStackTrace();
        }

    }

    /**
     * save tha given contact
     *
     * @param contact the contact to be saved
     * @param isNew true if contact is new, false if editing existent contact
     * @trows AlreadyExistentContactException if contact already exists
     */
    public static void saveContact(Contact contact, boolean isNew)
            throws ContactManagerException, AlreadyExistentContactException {

        Log.debug("[uicontroller savecontact] saving contact " + contact.getVisibleName() + " new = " + isNew);

        if (isNew) {

            Contact existentContact = contactManager.exists(contact.getDefaultEmail());
            if (existentContact != null) {
                throw new AlreadyExistentContactException(existentContact);
            }

            contactManager.addContact(contact, true);
        } else {
            contactManager.updateContact(contact);
        }

    }

    public synchronized static Vector getSortedMessages(
            int folderIdx) {
        Folder folder = messageManager.getFolder(folderIdx);
        return getSortedMessages(folder);
    }

    /**
     * getSortedMessages is synchronized to avoid potential issues
     * on concurrent access to the INbox elements in the storage
     * @return a sorted messageinfo with items from the given folderinfo
     */
    public synchronized static Vector getSortedMessages(
            Folder folder) {
        Log.stats("starting get sorted messages ");
        Vector list = new Vector();
        try {
            //String folderName = folder.getName();
            Message messages[] = messageManager.getMessagesInFolder(folder);


            for (int i = 0; i <
                    messages.length; ++i) {
                list.addElement(messages[i]);
            }

            if (list.size() > 0) {
                list = bubbleSortPerDate(list);
            }

            Log.stats("end get sorted messages ");

            return list;

        } catch (Exception ex) {
            Log.error("Error occurred sorting message list: " + ex.getMessage());
            Log.stats("Exiting getsortedMessages with exception");
            ex.printStackTrace();

            return list;
        }

    }

    /**
     * A sort algorithm to order the messages in the view Inbox as per sent date
     */
    public static Vector bubbleSortPerDate(
            Vector list) {
        int n = list.size();
        for (int pass = 1; pass <
                n; pass++) {  // count how many times
            // This next loop becomes shorter and shorter

            for (int i = 0; i <
                    n - pass; i++) {
                Message msg1 = (Message) list.elementAt(i);
                Message msg2 = (Message) list.elementAt(i + 1);
                long received1 = msg1.getReceivedTime();
                long received2 = msg2.getReceivedTime();
                if (received1 < received2) {
                    // exchange elements
                    Object temp = list.elementAt(i);
                    list.setElementAt(list.elementAt(i + 1), i);
                    list.setElementAt(temp, i + 1);
                }

            }
        }

        return list;
    }

    /**
     * reset the account deleting the store and startng a new
     * refresh_from_server sync
     */
    public static void resetAccount() {
        try {
            // For RAZR bug: wait before showing a new displayable
            //UIController.sleep(10);
            //UIController.showAlert(Localization.getMessages().RESETTING_ACCOUNT_MSG);

            //delete message store
            messageManager.initStore(true);
            //delete contact list and related PIM Item Queue
            if (contactManager == null) {
                contactManager =
                        ContactManagerFactory.getContactManager(ContactManager.RMS_TYPE);
            }


// reset the inbox view
            resetInboxMessageList();
            showInboxScreen();

            // empty the contact list (to free memory)
            contactManager.resetContactList();
            if (contactList != null) {
                contactList.resetContactList(new Message());
            }
//initialize new account's messages and contacts
            sync(SyncML.ALERT_CODE_REFRESH_FROM_SERVER, true);
            getInboxMessageList().setMinimumDisplayedMessageCount(
                    InboxMessageList.COUNT_NONE);
        } catch (RecordStoreException rse) {
            Log.error("resetAccount: " + rse.toString());
            // TODO: ALERT ??
            showInboxScreen();
        } catch (MailException me) {
            Log.error("resetAccount: " + me.toString());
            // TODO: ALERT ??
            showInboxScreen();
        }

    }

    /**
     * show the inbox and requests a refresh from server sync
     */
    public static void resetInboxFromServer()
            throws RecordStoreException, MailException {

        getInboxMessageList().rewindList();
        showInboxScreen();
        Log.debug("starting refresh from server...");
        sync(SyncML.ALERT_CODE_REFRESH_FROM_SERVER, false);
    }

    /**
     * Information on SyncClient status:
     * @return boolean false if some thread is sync'ing
     */
    public static boolean isSyncInProgress() {
        return SyncClient.getSyncClient().isBusy();
    }

    /**
     * reinit the contacts from server
     */
    public static void resetContacts() {

        if (contactList != null) {
            contactList.resetContactList(new Message());
            contactList.setContactCount(0);
        }
// TODO: attach listener
        sync(SyncClient.CONTACTS, SyncML.ALERT_CODE_REFRESH_FROM_SERVER);

    }

    public static void updateLogLevel(int logLevel) {
        Log.setLogLevel(logLevel);
    
        //read the configuration before saving it
        try {
            mailClientConfig = ConfigManager.getConfig();
        } catch (Exception e) {
            Log.error("[UIController.updateLogLevel]Exception reading configuration:" + e);
        }
    
        mailClientConfig.setLogLevel(logLevel);
        saveNewConfig(mailClientConfig);
    }

    public static InboxMessageList getInboxMessageList() {
        if (inboxMessageList == null) {
            Vector list = getSortedMessages(MessageManager.INBOX);
            inboxMessageList =
                    new InboxMessageList(list);
        }

        return inboxMessageList;
    }

    private static OutboxMessageList getOutboxMessageList() {
        if (outboxMessageList == null) {
            outboxMessageList = new OutboxMessageList(
                    getSortedMessages(messageManager.OUTBOX));

        }

        return outboxMessageList;
    }

    private static SentMessageList getSentMessageList() {
        if (sentMessageList == null) {
            sentMessageList = new SentMessageList(
                    getSortedMessages(MessageManager.SENT));
        }

        return sentMessageList;
    }

    private static DraftMessageList getDraftMessageList() {
        if (draftMessageList == null) {
            draftMessageList = new DraftMessageList(
                    getSortedMessages(MessageManager.DRAFTS));
        }

        return draftMessageList;
    }

    public static void changeFollowUpFlag(Message message) {
        changeFlag(message, MessageFlags.FLAGGED);
    }

    public static void changeReadFlag(Message message) {
        Log.debug("changing read flag");
        changeFlag(message, MessageFlags.OPENED);
    }

    /**
     * change the flag on the fly and start a thread to save the message
     * on rms.
     */
    private static void changeFlag(Message message, int flag) {
        boolean isFlagged = message.getFlags().isSet(flag);
        //message.getFlags().setFlag(flag, isFlagged);
        message.getFlags().setFlag(flag, !isFlagged);
        Log.debug("Starting ThreadedMessageWrite thread");
        threadedWriteMessageToFolder(message, true);

        Log.debug("[UIController] changeFlag of message: " + message + "--" + message.getKey() +
                " flag " + flag + " was " + isFlagged + " and now is " +
                message.getFlags().isSet(flag));

        if (UiUtils.isIncoming(message)) {
            Log.debug("[UIController] message is in inbox");
            try {
                getInboxMessageList().addMessage(message);
            } catch (MailException ex) {
                ex.printStackTrace();
                Log.error("UIController changeFlag() MailException  changing " +
                        "flag for message " + message.getSubject());
            }

        } else {
            if (message.getParent() == null) {
                Log.debug("[UIController] message has no parent folder");
            } else {
                Log.debug("[UIController] message is in folder " +
                        message.getParent().getFullName());
            }

            updateMessageList(message);
        }

    }

    /**
     * save a message to its parent folder and call the messageManager to add
     * the message to the queue
     */
    private static void threadedWriteMessageToFolder(final Message message,
            boolean update) {

        UIController.threadPool.startThread(getMessageWriter(message, update));
    }

    public static void sendMessage(Message message) {
        //checks if an address has been set to 
        if (!checkValidAddresses(message)) {
            showErrorDetailedAlert(
                    Localization.getMessages().INVALID_ADDRESS_FOUND_MSG,
                    Localization.getMessages().INVALID_ADDRESS_FOUND_LONG_MSG);
            return;
        }

        UIController.showInboxScreen();

        /*
         * this is to avoid that a message edited and sent from within the
         * Drafts once sent remains in the Drafts while it is in the Outbox
         */
        if (message.getParent() != null) {
            if (Store.DRAFTS.equals(message.getParent().getName())) {
                try {
                    messageManager.deleteMessage(message);
                } catch (Exception ex) {
                    Log.error("sendMessage: " + ex);
                    ex.printStackTrace();
                }

            }
        }

        try {
            message.setSentDate(new Date());
            message.setReceivedDate(new Date());
            message.getFlags().setFlag(MessageFlags.OPENED, true);
            messageManager.appendMessageToFolder(message, MessageManager.OUTBOX);

        //sync(false);

        } catch (Exception ex) {
            Log.error("Error moving message to Outbox");
            ex.printStackTrace();
            showErrorAlert(Localization.getMessages().SAVE_OUTBOX_ERROR);
        } finally {
        //    destroyAddressList();
        }
        sync(isFirstSync);

    }

    private static boolean checkValidAddresses(Message message) {
        Address[] to = message.getTo();
        Address[] cc = message.getCc();
        Address[] bcc = message.getBcc();
        Address[] replyTo = message.getReplyTo();

        for (int i = 0; i <
                to.length; i++) {
            if (to[i].getEmail().equals(Address.INVALID_ADDRESS)) {
                return false;
            }

        }

        for (int i = 0; i <
                cc.length; i++) {
            if (cc[i].getEmail().equals(Address.INVALID_ADDRESS)) {
                return false;
            }

        }

        for (int i = 0; i <
                bcc.length; i++) {
            if (bcc[i].getEmail().equals(Address.INVALID_ADDRESS)) {
                return false;
            }

        }

        for (int i = 0; i <
                replyTo.length; i++) {
            if (replyTo[i].getEmail().equals(Address.INVALID_ADDRESS)) {
                return false;
            }

        }

        return true;
    }

    /**
     * Start the sync of the messages, and optionally of the contacts
     * if the parameter syncContacts is true. The sync is done using the
     * default sync type defined for the source.
     */
    public static void sync(boolean syncContacts) {
        sync(-1, syncContacts);
    }

    /**
     * Start the SyncClient to send/receive email and, if
     * syncContacts is true, also to update the address book.
     * NOTE: if the contact sync is disabled in the config,
     *       the contact sync is not started, regardless of the value of
     *       the parameter syncContacts.
     *
     * @param syncMode the mode of the sync, as defined in SyncML class.
     *                 If the value -1 is passed, the default
     *                 value defined for the source will be used.
     * @param syncContacts true if the SyncClient should sync contacts too.
     */
    public static void sync(int syncMode, boolean syncContacts) {
        if (!syncContacts) {
            sync(SyncClient.MESSAGES, syncMode);
        } else {

            int repositories[] = new int[2];
            int modes[] = new int[2];

            repositories[0] = SyncClient.MESSAGES;
            repositories[1] = SyncClient.CONTACTS;

            modes[0] = syncMode;
            modes[1] = syncMode;
            sync(repositories, modes);
        }

    }

    /**
     * sync a single repository with given mode
     * @param repository
     * @param mode
     */
    public static void sync(int repository, int mode) {

        int repositories[] = {repository};
        int modes[] = {mode};
        sync(repositories, modes);


    }

    private static void sync(int[] repositories, int[] modes) {

        //#ifdef isBlackberry
        //# if (!BlackberryUtils.isDataConnectionAvailable()) {
        //#     FunambolAlert a = new FunambolAlert(  
        //#     Localization.getMessages().CONNECTION_UNAVAILABLE,
        //#     Localization.getMessages().PLEASE_TURN_ON_RADIO, AlertType.ERROR );
        //#     display.setCurrent(a, display.getCurrent());
        //#     return;
        //# }
        //#endif

        SyncClient sc = SyncClient.getSyncClient();

        MailSyncListener ml = new MailSyncListener();
        sc.setMailListener(ml);

        ContactSyncListener cl = new ContactSyncListener();
        sc.setContactListener(cl);

        sc.sync(repositories, modes);
    }

    public static void sendLaterMessage(Message message) {

        if (!checkValidAddresses(message)) {
            showErrorDetailedAlert(
                    Localization.getMessages().INVALID_ADDRESS_FOUND_MSG,
                    Localization.getMessages().INVALID_ADDRESS_FOUND_LONG_MSG);
            return;
        }

        try {

            removeDuplicates(message);
            message.setSentDate(new Date());
            message.setReceivedDate(new Date());
            messageManager.appendMessageToFolder(message, MessageManager.OUTBOX);
        //Log.debug("Message moved to outbox: "+ message.getParent().getName());
        } catch (Exception ex) {
            Log.error("SendLaterMessage: " + ex.toString());
            ex.printStackTrace();
        }
//updateOutboxMessageList(message);
//updateDraftMessageList(message);
//updateInboxMessageList(null);   //XXX why this???
        showAlert(
                Localization.getMessages().COMPOSE_MESSAGE_FORM_SAVED_TO_OUTBOX,
                getInboxMessageList());

    // destroyAddressList();
    }

    public static void saveMessage(Message message) {
        try {
            removeDuplicates(message);
            messageManager.appendMessageToFolder(message, MessageManager.DRAFTS);
            messageManager.updateMessageFlag(message, MessageFlags.DRAFT, true);
            //message.getFlags().setFlag(MessageFlags.DRAFT, true);
            //updateDraftMessageList(message);
            //updateInboxMessageList(null);
            showAlert(
                    Localization.getMessages().COMPOSE_MESSAGE_FORM_SAVED_TO_DRAFT,
                    getInboxMessageList());
        //destroyAddressList();
        //Log.debug("message saved to draft");
        } catch (Exception ex) {
            Log.error("UIC.savemessage: " + ex.toString());
            showErrorAlert(
                    Localization.getMessages().UNABLE_TO_SAVE_MESSAGE_TO_DRAFT,
                    getInboxMessageList());

        //  destroyAddressList();
        }

    }

    private static void removeDuplicates(final Message message)
            throws MailException, ConfigException {

        /*
         * this is to avoid that a message in the Drafts once edited and
         * saved to be sent later (i.e. stored in the Outbox) remains in the
         * Drafts while it is in the Outbox
         */
        if (message.getParent() != null) {
            if ("/Outbox".equals(message.getParent().getFullName()) ||
                    "/Drafts".equals(message.getParent().getFullName())) {
                messageManager.deleteMessage(message);
            }

        }
    }

    public static String getMyAddress() {
        mailClientConfig = getConfig();
        return (mailClientConfig.getMailAccount().getAddress());
    }

    /**
     * build the reply message of a given message.
     *
     */
//TODO: check the cc field, it seems not to work.
    public static void replyAll(Message message) {
        Message m = new Message();
        try {
            m.setCc(message.getCc());
            m.setTo(message.getReplyTo());
            Address[] to = message.getTo();
            for (int i = 0; i <
                    to.length; i++) {
                if (!StringUtil.equalsIgnoreCase(to[i].getEmail(), getMyAddress())) {
                    to[i].setType(Address.CC);
                    m.addRecipient(to[i]);
                }

            }
            m.setSubject(RE + message.getSubject());
            //setRepliedFlag(message);
            setDelayedFlag(message, MessageFlags.ANSWERED);
            updateComposeMessageScreen(m, getReplyText(message));
            // getContactList().emptySearchString();
            showComposeMessageScreen(display.getCurrent(), getComposeMessageScreen().body);
        } catch (MailException ex) {
            Log.error("Error in reply all message function: " + ex.getMessage());
            ex.printStackTrace();
        }

    }

    /**
     * Get the complete message (up to the maxObjSize).
     * This method relied on SyncClient.syncSingleMessage which is non blocking,
     * therefore this method is non blocking as well. The message can be got
     * by using a SingleMessageListener.
     */
    public static void getFullMessage(Message message) {

        Log.info("Get Full Message");
        try {
            String folder = message.getParent().getName();
            String luid = message.getKey();
            MailSyncSingleMessageListener lis =
                    new MailSyncSingleMessageListener(viewMessageScreen);
            SyncClient.getSyncClient().setSingleMessageListener(lis);
            SyncClient.getSyncClient().syncSingleMessage(folder, luid, false);
        } catch (ConfigException e) {
            Log.error("getFullMessage: " + e.toString());
            e.printStackTrace();
        } catch (MailException e) {
            Log.error("getFullMessage: " + e.toString());
            e.printStackTrace();
        }

    }

    private static String getReplyText(Message message) {
        StringBuffer sb = new StringBuffer();
        sb.append("\n\n");

        //added a delimiter
        sb.append("----\n");

        try {
            //TODO: use right timiezone offset here
            Date dateObj = message.getSentDate();
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(dateObj);
            calendar.setTimeZone(TimeZone.getDefault());

            // this is only for visualization purposes
            //TODO: check if the variables in formatLocalTime are really used
            String dateTime =
                    MailDateFormatter.getReplyDateString(
                    MailDateFormatter.formatLocalTime(calendar.getTime()));


            String date = dateTime.substring(0, dateTime.lastIndexOf(' '));
            String time = dateTime.substring(dateTime.lastIndexOf(' '));

            sb.append(Localization.getMessages().STRING_ON).
                    append(" ").append(date).append(" ").append(Localization.getMessages().STRING_AT).append(time).append("m, ").
                    append((message.getFrom() == null) ? "" : message.getFrom().getVisibleName()).
                    append(" ").append(Localization.getMessages().REPLY_WROTE).
                    append("\n").append(message.getTextContent());

        } catch (MailException ex) {
            ex.printStackTrace();
            Log.error("getReplyText() mailexception ");
        }

//Log.debug("replty text: \n----------------------\n" + sb.toString() + "\n-------------------------");
        return sb.toString();

    }

    private static FunambolAlert getFunambolAlert(String message,
            AlertType alertType, boolean autoDismiss) {

        FunambolAlert messageAlert = new FunambolAlert(
                Localization.getMessages().ALERT_TITLE,
                message,
                alertType);

        if (autoDismiss) {
            messageAlert.setTimeout(FunambolAlert.DEFAULT_TIMEOUT);
        } else {
            messageAlert.setTimeout(Alert.FOREVER);
        }

        return messageAlert;

    }

    private static FunambolAlert getFunambolDetailedAlert(String message, String longMessage,
            AlertType alertType, boolean autoDismiss) {

        FunambolAlert messageAlert = new FunambolAlert(
                Localization.getMessages().ALERT_TITLE,
                message,
                longMessage,
                alertType);

        if (autoDismiss) {
            messageAlert.setTimeout(FunambolAlert.DEFAULT_TIMEOUT);
        } else {
            messageAlert.setTimeout(Alert.FOREVER);
        }

        return messageAlert;

    }

    public static Address getMyFrom() {
        try {
            if (StringUtil.isNullOrEmpty(getMyAddress())) {
                return null;
            } else {
                return new Address(
                        Address.FROM,
                        mailClientConfig.getMailAccount().getName(),
                        getMyAddress());
            }

        } catch (MailException ex) {
            ex.printStackTrace();
            UIController.showAccountSettings(display.getCurrent());
            UIController.showErrorAlert(
                    Localization.getMessages().UNABLE_TO_FIND_PERSONAL_ADDRESS);
            Log.error("uicontroller getMyFrom() error " +
                    "getting from field, returning null");
            return null;
        }

    }

    /**
     * Returns the current MailClientConfig, or the default one
     * in case of errors.
     */
    public static MailClientConfig getConfig() {
        try {
            return ConfigManager.getConfig();
        } catch (ConfigException e) {
            // TODO shall we alert the user?
            Log.error("Error retrieving configuration: " + e.getMessage());
            MailClientConfig mcc = new MailClientConfig();
            try {
                ConfigManager.saveConfig(mcc);
            } catch (Exception ex) {
                Log.error("!!!Can't save default config!!! " + ex.toString());
            }

            return mailClientConfig;
        }

    }

    /**
     * Save the current configuration to the persistent storage.
     */
    public static void saveConfig() {
        try {
            ConfigManager.saveConfig();
        } catch (Exception e) {
            // TODO: shall we alert the user?
            Log.error("Error saving configuration: " + e.getMessage());
        }

    }

    /**
     * Save new configuration to persistent memory.
     * If username field is changed a new account is initialized and
     * slow sync are performed both for contact list and Emails
     * @param mailClientConfig is the new configuration to be saved
     */
    public static void saveNewConfig(MailClientConfig mailClientConfig) {
        try {
            MailClientConfig oldConfig = ConfigManager.getConfig();
            Account oldAccount = oldConfig.getMailAccount();
            Account newAccount = mailClientConfig.getMailAccount();
            String oldUrl = oldAccount.getUrl();
            String newUrl = newAccount.getUrl();
            String oldUser = oldAccount.getUser();
            String newUser = newAccount.getUser();
            String oldPassword = oldAccount.getPassword();
            String newPassword = newAccount.getPassword();
            
            String server = null;
            boolean isAccountChanged = false;
            
            if ((oldUrl != null && !oldUrl.equals(newUrl))||
                (oldUser != null && !oldUser.equals(newUser))||
                (oldPassword != null && !oldPassword.equals(newPassword))) {
                
                server = StringUtil.extractAddressFromUrl(newUrl, "http");
                Log.debug("[UIController.saveNewConfig]New Server Found:");
                Log.debug("[UIController.saveNewConfig]" + server);
                UpdaterManager.getInstance().setUrl(server);
                Log.debug("[UIController.saveNewConfig]UpdaterManager Server updated");
                
                Log.debug("[UIController.saveNewConfig]CTP Server must be restarted");
                isAccountChanged = true;
            }

            ConfigManager.saveConfig(mailClientConfig);
            
            //Restart the CTP Service if a new account has been found
            if (isAccountChanged) {
                CTPManager.getInstance().restartCTP(mailClientConfig);
            }
                
        } catch (Exception e) {
            Log.error("Unable to save new configuration: " + e.getMessage());
            e.printStackTrace();
        }

    }

    /**
     * Loads the source config from the store, if present.
     *
     * @param name the name of the source to load.
     * @return the config, or null in case of error.
     */
    public static SourceConfig getSourceConfig(
            String name) {
        SourceConfig ret = new SourceConfig();
        try {
            ConfigManager.load("source." + name, ret);
            return ret;

        } catch (Exception e) {
            Log.error("getSourceConfig: " + e.toString());
            return null;
        }

    }

    /**
     * Save the given source config.
     *
     * @param sc the SourceConfig to save.
     *
     * @throws ConfigException if the config is not present
     * @throws IOException if an error occurred during the deserialization
     */
    public static void saveSourceConfig(SourceConfig sc) {
        try {
            // The source config is stored in a record named "source.<sourcename>"
            ConfigManager.save("source." + sc.getName(), sc);
            Log.info("[UIController] config for source " + sc.getName() + " saved.");

        } catch (Exception e) {
            Log.error("saveSourceConfig: " + e.toString());
        // TODO: shall we put an alert here?
        }

    }

    /** Enable or disable contact synchronization. */
    public static void enableContactSync(boolean enable) {
        SourceConfig sc = getSourceConfig(SourceConfig.CONTACT);
        if (sc != null) {
            if (enable) {
                sc.setSyncMode(SyncML.ALERT_CODE_FAST);
            } else {
                sc.setSyncMode(SyncML.ALERT_CODE_NONE);
            }

            saveSourceConfig(sc);
        }

    }

    public static void deleteMessage(Message msg) {
        try {
            messageManager.deleteMessage(msg);
            getMessageList(msg).deleteMessage(msg.getKey());
        } catch (Exception ex) {
            ex.printStackTrace();
            Log.error("uicontroller deleteMessage() error deleting" +
                    " message " + msg.getSubject());
            showErrorAlert(
                    Localization.getMessages().
                    getGENERIC_UNABLE_TO_DELETE_MESSAGE(msg.getSubject()));
        }

    }

    public static String getVersion() {
        return ConfigManager.getClientVersion();
    }

    public static String getClientName() {

        return ConfigManager.getClientName() + " " + Localization.getMessages().ABOUT_SCREEN_CLIENT_NAME_SUFFIX;
    }

    public static String getClientVendor() {
        return ConfigManager.getClientVendor();
    }

    public static void emptyFolder(int folderId) {
        try {
            messageManager.emptyFolder(folderId);

        } catch (MailException ex) {
            ex.printStackTrace();
            Log.error("unable to recreate folder " + folderId);
        //TODO: add alert
        }

    }

    public static void showAdvancedContactScreen(Contact contact) {
        backStack.push(display.getCurrent());
        UIController.display.setCurrent(new AdvancedContactForm(contact));
    }

    /**
     * delete a contact
     **/
    public static void deleteContact(Contact contact) {
        try {
            UIController.contactManager.removeContact(contact.getContactId());
        } catch (ContactManagerException ex) {
            UIController.showErrorAlert(
                    Localization.getMessages().UNABLE_TO_DELETE_CONTACT);
        }

    }

    public static void synchContacts() throws SyncException {
        if (contactManager.getContactCount() >= contactManager.getDefaultContactNumber()) {
            Log.info("[UIController] Addressbook is full. Remove some contact from server and try again.");
            UIController.showAlert(Localization.getMessages().AB_LIMIT_ERROR_MSG);
            getContactList().setTitle(getContactList().getDefaultTitle());
            return;
        }

        SourceConfig sc = getSourceConfig(SourceConfig.CONTACT);
        // Check if the contact sync is not enabled.
        if (sc != null && sc.getSyncMode() == SyncML.ALERT_CODE_NONE) {
            Log.info("Contact sync disabled.");
        } else {
            //SyncClient.getSyncClient().sync(SyncClient.CONTACTS);
            SyncClient syncClient = SyncClient.getSyncClient();
            ContactSyncListener cl = new ContactSyncListener();
            syncClient.setContactListener(cl);
            sync(SyncClient.CONTACTS, -1);


        }

    }

    private static String getForwardText(Message message) {
        return getReplyText(message);
    }

    public static void createContactManager() {
        try {
            Log.info("Creating Contact Store.");
            contactManager =
                    ContactManagerFactory.getContactManager(
                    ContactManager.RMS_TYPE);
        } catch (RecordStoreException ex) {
            Log.error("createContactManager: " + ex.toString());
            ex.printStackTrace();
        }

    }

    public static void resetInboxTitle() {
        getInboxMessageList().resetTitle();
    }

    /**
     * resort inbox messageinfo list
     */
    public static void resortInboxMessages() {
        getInboxMessageList().setMessageList(
                bubbleSortPerDate(getInboxMessageList().getMessageList()));
    }

    /**
     * reload the inbox messages from rms and reset the inbox title to the default title
     */
    public static void resetInboxMessageList() {

        inboxMessageList = getInboxMessageList();
        inboxMessageList.setTitle(inboxMessageList.getDefaultTitle());
        reloadInboxMessageListMessages();
    }

    /**
     * reload the inbox message list messages
     *
     */
    public static void reloadInboxMessageListMessages() {
        getInboxMessageList().setMessageList(
                getSortedMessages(MessageManager.INBOX));
    }

    public static void showModalPopup(ModalPopup popup, Displayable displayable) {
        backStack.push(displayable);
        display.setCurrent(popup);
    }

    /**
     * @return the contactmanager
     */
    public static ContactManager getContactManager() {
        if (null == contactManager) {
            createContactManager();
        }

        return contactManager;
    }

    /**
     * shows the given displayable
     * @param toShow the displayable to show
     * @param backscreen the displayable to push in the stack.
     */
    public static void showDisplayable(Displayable toShow, Displayable backscreen) {
        backStack.push(backscreen);
        display.setCurrent(toShow);
    }

    public static ContactList getContactList() {

        if (contactList == null) {
            contactList = new ContactList();
        }

        return contactList;
    }

    private static Runnable getPlatformRequestHandler(String request) {
        if (prh == null) {
            prh = new PlatformRequestHandler(midlet);
        }

        prh.setRequest(request);

        return prh;

    }

    private static Runnable getMessageWriter(Message message, boolean update) {

        if (messageWriter == null) {
            messageWriter = new MessageWriter();
        }

        messageWriter.setMessage(message);
        messageWriter.setUpdate(update);

        return messageWriter;

    }

    public static void threadedPlatformRequest(String request) {
        UIController.threadPool.startThread(getPlatformRequestHandler(request));
    }

    public static boolean checkContactListFull() {
        return (getContactManager().getContactCount() >=
                getContactManager().getDefaultContactNumber() && getContactManager().getDefaultContactNumber() != -1);
    }

    /**
     * return the message related message list
     * @param message is the reference message
     */
    public static MessageList getMessageList(
            Message message) {
        String folderName = message.getParent().getName();
        if (folderName.equals(Store.INBOX)) {
            return getInboxMessageList();
        } else if (folderName.equals(Store.OUTBOX)) {
            return getOutboxMessageList();
        } else if (folderName.equals(Store.DRAFTS)) {
            return getDraftMessageList();
        } else if (folderName.equals(Store.SENT)) {
            return getSentMessageList();
        }

        return null;
    }

    public static Drawer getDrawer() {
        return DrawerFactory.getDrawer();
    }

    public static void handleAdClick(Ads ad) {

        if (minTimeElapsed()) {

            if (ad.getAdType() == Ads.AD_FULLSCREEN) {
                display.setCurrent(new AdCanvas(ad));
            } else {
                ad.doAction();
                ad.toNextAd();
            }

        }

    }

    private static void doPlatformRequest(String request) throws Exception {
        //#ifdef Exit
//#         ModalPopup popup =
//#                 new ModalPopup(Localization.getMessages().POPUP_EXIT_TITLE,
//#                 Localization.getMessages().POPUP_PLATFORM_REQUEST_EXIT,
//#                 new PlatformRequestPopupAction(request));
//#         UIController.showModalPopup(popup, display.getCurrent());
//#
        //#endif

        //#ifdef Threaded
//#         threadedPlatformRequest(request);
        //#elifndef Exit
        midlet.platformRequest(request);
    //#endif
    //exit form Exit block
    }

    /**
     * call a phonenumber.
     *
     * @param contact the contact to be call
     */
    public static void phoneCall(Contact contact, Displayable backScreen) {
        Log.info("Start phone call");

        try {
            if (StringUtil.isNullOrEmpty(contact.getHomePhone()) && StringUtil.isNullOrEmpty(contact.getJobPhone())) {
                doPlatformRequest("tel:" + checkPhoneNumberFormat(contact.getMobilePhone()));
            } else if (StringUtil.isNullOrEmpty(contact.getHomePhone()) && StringUtil.isNullOrEmpty(contact.getMobilePhone())) {
                doPlatformRequest("tel:" + checkPhoneNumberFormat(contact.getJobPhone()));
            } else if (StringUtil.isNullOrEmpty(contact.getJobPhone()) && StringUtil.isNullOrEmpty(contact.getMobilePhone())) {
                doPlatformRequest("tel:" + checkPhoneNumberFormat(contact.getHomePhone()));
            } else {
                backStack.push(backScreen);
                display.setCurrent(new ContactPhoneNumbersList(contact));
            }

        } catch (ConnectionNotFoundException ex) {
            ex.printStackTrace();
            Log.error("calling phonenumber: " + ex.toString());
            showErrorAlert("Error calling phonenumber.");

        } catch (Exception e) {
            e.printStackTrace();
            Log.error("calling phonenumber: " + e.toString());
        }

    }

    private static String checkPhoneNumberFormat(String phoneNumber) {
        StringBuffer num = new StringBuffer();

        for (int i = 0; i <
                phoneNumber.length(); i++) {
            char charToCheck = phoneNumber.charAt(i);
            if (charToCheck == '(') {
            //Do nothing
            } else if (charToCheck == ')') {
            //Do nothing
            } else if (charToCheck == ' ') {
            //Do nothing
            } else if (charToCheck == '-') {
            //Do nothing
            } else {
                num.append(charToCheck);
            }

        }

        phoneNumber = num.toString();
        num =
                null;

        return phoneNumber;
    }

    /**
     * reset the titles after a sync.
     * currently used only to reset the title of the viewmessage screen if
     * get full operation is not completed correctly or reset the inbox when errors
     * during sync occurred
     * 
     */
    static void resetTitles() {
        getInboxMessageList().resetTitle();
        if (viewMessageScreen != null) {
            viewMessageScreen.resetTitle();
        }

    }

    /**
     * return true if the given key is a clear key.
     */
    public static boolean isClearKey(int keyCode) {

        return (keyCode == '0' || //
                keyCode == -8 || // cancel key code
                keyCode == 8 || // backspace code
                keyCode == ' ' // space
                );

    }
//#ifndef noPhoto
//#
//#    public static void showSendPhotoScreen(ImageAttachment i) {
//#
//#        display.setCurrent(new SendPhotoScreen(i));
//#
//#    }
//#endif
    /**
     * orrible -and temporary- hack to fix  multi-handlekey calls on bb
     **/
    private static boolean minTimeElapsed() {


        boolean ret = true;
        //#ifdef isBlackberry
        //# long now = System.currentTimeMillis();
        //# ret = (now > lastTimeStarKeypressed + 500) ;
        //# if (!ret){
        //# Log.debug("dropping keypressed");
        //# }
        //# lastTimeStarKeypressed = now;
        //#endif

        return ret;


    }

    public static void sendPhoto(ImageAttachment imageAttachment) {


        //creating multipart message
        Message mailMessage = new Message();

        //setting default subject
        Address address = getMyFrom();
        if (address != null && !StringUtil.isNullOrEmpty(address.getName().trim())) {
            mailMessage.setSubject(address.getName() + " " + Localization.getMessages().SUBJECT_SEND_PHOTO_WITH_SENDER);
        } else {
            mailMessage.setSubject(Localization.getMessages().SUBJECT_SEND_PHOTO_WITHOUT_SENDER);
        }

        mailMessage.setLaziness(Message.LAZY_CONTENT);
        Multipart multipart = new Multipart();

        /** the first bodypart content is empty, because is the text body
         * of the mail, it will set in the composeMessageForm.
         */
        BodyPart bodyPart = new BodyPart();
        bodyPart.addHeader(BodyPart.CONTENT_TRANSFER_ENCODING, "8bit");
        multipart.addBodyPart(bodyPart);

        /** in the second bodypart content set the photo in byte array
         */
        bodyPart =
                new BodyPart();
        bodyPart.setDisposition(BodyPart.CD_ATTACHMENT);
        bodyPart.addHeader(BodyPart.CONTENT_TRANSFER_ENCODING, "base64");
        bodyPart.setContent(imageAttachment.getContent());
        bodyPart.setFileName(imageAttachment.getName());
        bodyPart.setContentType(imageAttachment.getContentType());
        multipart.addBodyPart(bodyPart);
        mailMessage.setContent(multipart);

        getComposeMessageScreen().setMessage(mailMessage);
        // we need to set the message here, because
        // composemessagescree.setmessage does not
        // (for speed reasons)
        getContactList().setMessage(mailMessage);
        getContactList().emptySearchString();
        getContactList().SortAlphabetically();
        showContactList(display.getCurrent());

    }

    public static Ads getAd() {
        if (ad == null) {
            ad = new Ads();
        }

        return ad;
    }

//#ifndef noPhoto
//# public static void showTakePhotoScreen(Displayable d) {
//#    backStack.push(d);
//#    getCameraCanvas().stopPlayer();
//#    getCameraCanvas().showCamera();
//#    display.setCurrent(getCameraCanvas());
//# }
//#endif
    public static void showAttachedImage(Displayable d, ImageAttachment img) {
        backStack.push(d);
        display.setCurrent(new ViewAttachedImageScreen(img));

    }

//#ifndef noPhoto
//# public static CameraCanvas getCameraCanvas() {
//#    if (cameraCanvas == null) {
//#        cameraCanvas = new CameraCanvas();
//#    }
//#    return cameraCanvas;
//# }
//#endif
    /**
     * Sets the number of unread messages in the inbox
     *
     * @param counter the new value
     */
    public static void setInboxUnreadCounter(int counter) {
        inboxUnread = counter;
        if (inboxMessageList != null && !isSyncInProgress() && !ServerCapFiller.isGettingServerCapabilities()) {
            getInboxMessageList().resetTitle();

        }

    }

    /**
     * Gets the number of unread messages in the inbox.
     * If this value is not initialized, then -1 is returned.
     */
    public static int getInboxUnreadCounter() {
        return inboxUnread;
    }

    public static void loadContacts() {
        contactsLoader = new ContactsLoader();
        contactsLoader.lock();

        Thread t = UIController.getThreadPool().startThread(contactsLoader);
        t.setPriority(Thread.MIN_PRIORITY);
    }

    public static ContactsLoader getContactsLoader() {
        return contactsLoader;
    }

    public static void checkTimerAlarmAfterSync() {
        if (syncCaller == USER) {

        } else if (syncCaller == SAN_MESSAGE) {
            //Cancel the timer task if the sync ends succesfully
            AlarmManager.getInstance().cancelTimerTask();
        } else if (syncCaller == SCHEDULER) {

        } else if (syncCaller == CONNECTION_ERROR_TIMER) {

        }
    }

    public static int getSyncCaller() {
        return syncCaller;
    }

    public static void setSyncCaller(int syncCaller) {
        switch (syncCaller) {
            case USER:
                Log.info("SyncCaller set to USER");
                alarmCounter =
                        0;
                break;
            case SCHEDULER:
                Log.info("SyncCaller set to SCHEDULER");
                if (syncCaller != SCHEDULER) {
                    alarmCounter = 0;
                }

                break;
            case SAN_MESSAGE:
                Log.info("SyncCaller set to SAN_MESSAGE");
                if (syncCaller != SAN_MESSAGE) {
                    alarmCounter = 0;
                }

                break;
            default:
                break;
        }

        UIController.syncCaller = syncCaller;
    }

    public static void handleSmartSlowSyncUnsupported() {
        String msg = Localization.getMessages().SMART_SLOW_SYNC_UNSUPPORTED;
        UIController.enableSyncCommandsKeepingSettings(false);
        //UIController.
        UIController.showErrorAlert(msg);
        UIController.resetTitles();
        CTPManager.getInstance().setOfflineMode(true);
    }
    }

/**
 * private class to handle platform request
 */
class PlatformRequestHandler
        implements Runnable {

    private String request;
    private MIDlet midlet;

    public PlatformRequestHandler(Funambol midlet) {
        this.midlet = midlet;
    }

    public void setRequest(String request) {
        this.request = request;
    }

    public void run() {
        try {
            midlet.platformRequest(request);
        } catch (ConnectionNotFoundException cnfe) {
            cnfe.printStackTrace();
            Log.error("Cannot complete platform request: \n" + cnfe.getMessage());
        }

    }
}

/**
 * private class for writing message to folder
 */
class MessageWriter implements Runnable {

    private Message message = null;
    private boolean update = false;

    public MessageWriter() {
    }

    public void setMessage(Message m) {
        message = m;
    }

    public void setUpdate(boolean update) {
        this.update = update;
    }

    public void run() {
        if (message != null) {
            // This method simply updated the FlagQueue
            Log.debug("[MessageWriter]Calling MessageManager to update the flag queue");
            UIController.messageManager.updateMessageFlags(message,
                    message.getFlags());
            Log.debug("[MessageWriter]MessageManager updated the flag queue");
            try {
                if (update) {
                    Log.debug("[MessageWriter] about to update message");
                    UIController.messageManager.updateMessage(message);
                    Log.debug("[MessageWriter] message updated");
                } else {
                    message.getParent().appendMessage(message);
                }
            } catch (MailException ex) {
                Log.error("threadedWriteMessageToFolder: ", ex.toString());
                ex.printStackTrace();
            } finally {
                message = null;
            }
        }
    }
}
