/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 *
 *
 */

package com.funambol.mailclient.ui.view;

import javax.microedition.lcdui.Font;

/**
 *a color theme
 *
 */

/*
 * TODO: this should really be turned into an (abstract?) class, as some methods
 * should have default values
 */
public interface GraphicalTheme {
    /**
     * @return backgroung color
     */
    int getBackgroundColor();
    
    /**
     * @return border color
     */
    int getBorderColor();
    
    /**
     * @return title color
     */
    int getTitleColor();
    
    /**
     * @return the title background color
     */
    int getTitleBackgroundColor() ;
    
    /**
     * @return the title border color
     */
    int getTitleBorderColor() ;
    
    /**
     *@return title font
     */
    Font getTitleFont();
    
    
    /**
     *@return default font
     */
    Font getDefaultFont();
    
    /**
     *@return small  font
     */
    Font getSmallFont();
    
    /**
     *@return small bold font
     */
    Font getSmallBoldFont();
    
    
    /**
     *@return bold font
     */
    Font getBoldFont();
    
    /**
     * @return the foreground color
     */
    int getForegroundColor();
    
    /**
     * @return the highlighted bg color
     */
    int getHighlightedBackgroundColor();
    
    /**
     * @return the highlighted bordere color
     */
    int getHighlightedBorderColor();
    
    /**
     * @return the highlighted foreground color
     */
    int getHighlightedForegroundColor();
    
    /**
     * set the background color
     */
    void setBackgroundColor(int backgroundColor);
    /**
     * set the  color
     */
    void setBorderColor(int borderColor);
    
    /**
     * set the foreground color
     */
    void setForegroundColor(int foregroundColor);
    
    /**
     * set the highlighted background color
     */
    void setHighlightedBackgroundColor(int highlightedBackgroundColor);
    
    /**
     * set the  highlighted border color
     */
    void setHighlightedBorderColor(int higlightedBorderColor);
    
    /**
     * set the highlighted foreground color
     */
    void setHighlightedForegroundColor(int higlightedForegroundColor);

    /**
     * get the background color for the scrollbar
     */
    int getScrollbarBackgroundColor();
    
    
}
