/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 *
 *
 */

package com.funambol.mailclient.ui.view;

import com.funambol.mailclient.loc.Localization;
import com.funambol.mailclient.ui.controller.UIController;
import com.funambol.mailclient.ui.utils.UiUtils;

//#ifndef noPhoto
//# import com.funambol.mailclient.ui.view.CameraCanvas;
//#endif

import com.funambol.mailclient.ui.utils.ImageAttachment;
import com.funambol.util.Log;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;


public class SendPhotoScreen extends Form
        implements CommandListener {
    
    private Command sendCommand;
    private Command discardCommand;
    
    private ImageAttachment imageAttachment;
    private Image image;
    /** Creates a new instance of SendPhotoScreen */
    
    public SendPhotoScreen(ImageAttachment img){
        
        super(Localization.getMessages().SEND_PHOTO_SCREEN_TITLE);
        this.image = Image.createImage(img.getContent(), 0, img.getContent().length);
        
        this.imageAttachment = img;
        sendCommand = new Command(Localization.getMessages().ADD_RECIPIENTS_TO_PHOTO,
                Command.OK, 0);
        discardCommand = new Command(Localization.getMessages().DISCARD_COMMAND_LABEL,
                Command.BACK, 0);
        addCommand(sendCommand);
        addCommand(discardCommand);
        this.setCommandListener(this);
        this.append(UiUtils.bestFit(image, getWidth(), getHeight()));
        
    }
    
    public SendPhotoScreen(){
        super("");
        this.append(Localization.getMessages().PLEASE_WAIT);
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if (command == sendCommand) {
            Log.info("send command pressed!");
            UIController.sendPhoto(imageAttachment);
            // we can kill the image since we'll never need it again
            image = null;
        } else if (command == discardCommand) {
            // we can kill the image since we'll never need it again
            image = null;
            imageAttachment = null;
            //back to the take photo screen
//#ifndef noPhoto
//#                UIController.showTakePhotoScreen(null);
//#endif            
        }
    }
    
   
    
   
}

